using System;
using System.Data;
using System.Collections;
using Core.Mes.ServerFrameWork;
using Core.Mes.IBaseInterface;

namespace Core.XgMes.Server.JGKC.RollManager
{
	/// <summary>
	/// TurnoffMove 的摘要说明。
	/// </summary>
	public class TurnoffMove : Core.Mes.ServerFrameWork.IComponent
	{
		public TurnoffMove()
		{
			//
			// TODO: 在此处添加构造函数逻辑
			//
		}

		

		//成品库信息
		public ReturnObject Turn_Query(string _Where)
		{
			try
			{
				string strOut="";
				string Sql="SELECT 'FALSE'  FLAG,A.COIL_NO_ID,A.OLD_SAMPL_NO,A.SLAB_NO,A.ORD_NO,B.BUTTRESS,"+
					       "A.ORD_SEQ,A.STL_GRD,A.ZSLAB_PLY,A.ZSLAB_WIDTH,B.AREA, "+
					       "A.ZSLAB_LENGTH,ZSLAB_NUM,A.STOVENO,(A.BAHCT_NUMBER||A.SERIAL_NUMBER)BAHCT_NUMBER,"+
					       "ROUND(A.ZSLAB_WEIGHT*0.001,3)ZSLAB_WEIGHT,A.TOT_DEC_GRD,B.REMARK,A.REM FROM KCJ3_TURNOFFLIST_ZW A ,KCJ3_TURNOFFBUTTRESSLIST_ZW B "+
					       "WHERE A.COIL_NO_ID=B.COIL_NO_ID AND A.STORAGESTATUS='501602' AND ISVALID='1'"+_Where;
				DataSet ds=this.DBManager.ExecuteQuery(Sql,out strOut);
				if(ds!=null&&ds.Tables.Count==1)
				{
					ds.Tables[0].TableName="KCJ3_TURNOFFLIST";
					return new ReturnObject(ds,strOut);
				}
				return new ReturnObject(null);
			}
			catch(Exception ex)
			{
				System.Diagnostics.Debug.WriteLine(ex.ToString());
				return new ReturnObject(null,10004,ex.ToString());
			}
		}
//        //移堆之后的信息
//		public ReturnObject MoveBuressQuery(string _Where)
//		{
//			try
//			{
//				string strOut="";
//				string Sql="SELECT 'FALSE'  FLAG,A.COIL_NO_ID,A.OLD_SAMPL_NO,A.SLAB_NO,A.ORD_NO,B.BUTTRESS,"+
//					"A.ORD_SEQ,A.STL_GRD,A.ZSLAB_PLY,A.ZSLAB_WIDTH,"+
//					"A.ZSLAB_LENGTH,ZSLAB_NUM,A.STOVENO,(A.BAHCT_NUMBER||A.SERIAL_NUMBER)BAHCT_NUMBER,"+
//					"A.ZSLAB_WEIGHT,A.TOT_DEC_GRD FROM KCJ3_TURNOFFLIST A ,KCJ3_TURNOFFBUTTRESSLIST B "+
//					"WHERE A.COIL_NO_ID=B.COIL_NO_ID AND A.STORAGESTATUS='501602' AND ISVALID='1' AND B.BUTTRESS='"+_Where+"'";
//				DataSet ds=this.DBManager.ExecuteQuery(Sql,out strOut);
//				if(ds!=null&&ds.Tables.Count==1)
//				{
//					ds.Tables[0].TableName="KCJ3_TURNOFFLIST";
//					return new ReturnObject(ds,strOut);
//				}
//				return new ReturnObject(null);
//			}
//			catch(Exception ex)
//			{
//				System.Diagnostics.Debug.WriteLine(ex.ToString());
//				return new ReturnObject(null,10004,ex.ToString());
//			}
//		}
		public ReturnObject TurnMoveBuress(ArrayList _Ship_Invno,ArrayList _OtherInfo)
		{
			try
			{
				string err = "";
				Oracle.DataAccess.Client.OracleParameter pShi_Invno = new Oracle.DataAccess.Client.OracleParameter("vSHIP_INVNO", Oracle.DataAccess.Client.OracleDbType.Varchar2);
				Oracle.DataAccess.Client.OracleParameter pOtherInfo = new Oracle.DataAccess.Client.OracleParameter("vOtherInfo", Oracle.DataAccess.Client.OracleDbType.Varchar2);
				Oracle.DataAccess.Client.OracleParameter pSuccessFlag = new Oracle.DataAccess.Client.OracleParameter("vSuccessFlag", Oracle.DataAccess.Client.OracleDbType.Varchar2);
				
				pShi_Invno.Direction = ParameterDirection.Input;
				pOtherInfo.Direction = ParameterDirection.Input;
				pSuccessFlag.Direction = ParameterDirection.Output;

				pShi_Invno.CollectionType = Oracle.DataAccess.Client.OracleCollectionType.PLSQLAssociativeArray;
				pOtherInfo.CollectionType = Oracle.DataAccess.Client.OracleCollectionType.PLSQLAssociativeArray;

				pShi_Invno.Value = _Ship_Invno.ToArray(typeof(string));
				pOtherInfo.Value = _OtherInfo.ToArray(typeof(string));

				int []OSizeInf = new int[_Ship_Invno.Count];
				for(int i =0;i< _Ship_Invno.Count;i++)
				{
					OSizeInf[i ] = 200;
				}
				pShi_Invno.Size = _Ship_Invno.Count;
				pShi_Invno.ArrayBindSize = OSizeInf;

				int []NOSizeInf = new int[_OtherInfo.Count];
				for(int i =0;i< _OtherInfo.Count;i++)
				{
					NOSizeInf[i ] = 200;
				}
				pOtherInfo.Size = _OtherInfo.Count;
				pOtherInfo.ArrayBindSize = NOSizeInf;
				pSuccessFlag.Size = 400;

                ((STMes.DBManager)DBManagerList["ODPDBZW"]).ExecuteNonQuery_NoDBSever("KCJ_STORAGEMANAGER_WX.TURNBURESS_UPDATE", CommandType.StoredProcedure,
					new Oracle.DataAccess.Client.OracleParameter[]
					{pShi_Invno,pOtherInfo,pSuccessFlag}, out err);
				if(Common.CheckNullStr(pSuccessFlag.Value).Length>0 | Common.CheckNullStr(err).Length>0)
				{
					return new ReturnObject(null,1,pSuccessFlag.Value.ToString()+err);
				}
				else
				{
					return new ReturnObject('1');
				}
			}
			catch(System.Exception ex)
			{
				System.Diagnostics.Debug.WriteLine(ex.ToString());
				return new ReturnObject(null,ex.ToString());
			}
		}
	}
}
